#
# Aura Engine (https://gitlab.servus.at/aura/engine)
#
# Copyright (C) 2017-2020 - The Aura Engine Team.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


"""
A collection of exceptions.
"""

# Scheduler Exceptions


class NoProgrammeLoadedException(Exception):
    """
    Exception thrown when no programme data could be loaded.
    """

    pass


class NoActiveTimeslotException(Exception):
    """
    Exception thrown when there is no timeslot active.
    """

    pass


# Soundsystem and Mixer Exceptions


class LoadSourceException(Exception):
    """
    Exception thrown when some source could not be loaded.
    """

    pass


class InvalidChannelException(Exception):
    """
    Exception thrown when the given channel is invalid.
    """

    pass


class PlaylistException(Exception):
    """
    Exception thrown when the playlist is invalid.
    """

    pass


class NoActiveEntryException(Exception):
    """
    Exception thrown when there is no playlist entry active.
    """

    pass


# Liquidsoap Exceptions


class LQConnectionError(Exception):
    """
    Exception thrown when there is a connection problem with Liquidsoap.
    """

    pass


class LQStreamException(Exception):
    """
    Exception thrown when there is a problem with an audio stream in Liquidsoap.
    """

    pass
